{-# LANGUAGE FlexibleContexts, TemplateHaskell, TypeFamilies, ScopedTypeVariables, ViewPatterns #-}
module EdgeBX where
import Generics.BiGUL
import Generics.BiGUL.Interpreter
import Generics.BiGUL.TH
import Generics.BiGUL.Lib
import Generics.BiGUL.Lib.List
import Data.List
import Data.Maybe
import GHC.Generics
import Debug.Trace
import Format
import PRBAC
import PolicyAlign
import System.IO  
import Control.Monad
import Text.Regex
import Control.Exception
import Data.Time
import TableFormat
import Control.DeepSeq

polexample :: Policy
--polexample = Pol (Rol "ML") (DP ("Write","labs")) (Pur "MedicalCare") (Con (("LabDateTime",""),"NEqual")) (ONull)
--polexample = Pol (Rol "DO") (DP ("Write","diagnosis")) (Pur "MedicalCare") (Con (("",""),"")) (ONull)
--polexample = Pol (Rol "PR") (DP ("Write","labs")) (Pur "Storage") (Con (("",""),"")) (Obl "notify")
--polexample = Pol (Rol "HL") (DP ("Read","patients")) (Pur "Statistics") (Con (("",""),"")) (ONull)
polexample = Pol (Rol "UV") (DP ("Read","diagnosis")) (Pur "Research") (Con (("DiagnosisCore","Q21"),"Equal")) (ONull)

tableSourceName::[String]
tableSourceName = ["diagnosis"]

tableViewName::[String]
tableViewName = ["diagnosis"]

tableName::[String]
tableName = ["diagnosis"]


--()    <- rnf bis
--getClockTime >>= putStrLn . show

getview_time = do  
        let bis = readfiles tableName
        evaluate $  bis
     --   print bis
        start <- getCurrentTime
        let biv = fromJust $ get (policysyn polexample) bis
        evaluate $  biv
     --   print biv
        end <- getCurrentTime
        print (diffUTCTime end start)


getview = do  
        let bis = readfiles tableName
        evaluate $  bis
        let biv = fromJust $ get (policysyn polexample) bis
        writeFile "result.txt" "this is the source:\n"
        appendFile "result.txt" (showobject2 bis)
        appendFile "result.txt" "this is the view:\n"
        appendFile "result.txt" (showobject2 biv)

updatesource = do  
        let bis = readfiles tableName
        evaluate $  bis
        let biv = readfiles tableName
        evaluate $  biv
        let biss = fromJust $ put (policysyn polexample) bis biv
        writeFile "result.txt" "this is the source:\n"
        appendFile "result.txt" (showobject bis 0)
        appendFile "result.txt" "\n\nthis is the view:\n"
        appendFile "result.txt" (showobject biv 0)
        appendFile "result.txt" "\n\nthis is the new source:\n"
        appendFile "result.txt" (showobject biss 0)

